#include "qfontcache_crash.h"
#include <QApplication>
#include <QDir>
#include <QHBoxLayout>
#include <QLibrary>
#include <QPushButton>
#include <QDebug>
#include <QFileDialog>

QLibrary *lib = NULL;
QWidget *dllWidget = NULL;
typedef QWidget*(*WidgetFunc)();

qfontcache_crash::qfontcache_crash(QWidget *parent)
    : QMainWindow(parent)
{
    QWidget *newCentralWidget = new QWidget(this);
    QHBoxLayout *horizontalLayout = new QHBoxLayout(newCentralWidget);
    QPushButton *pushButton = new QPushButton("load", newCentralWidget);
    QPushButton *pushButton_2 = new QPushButton("unload", newCentralWidget);
    horizontalLayout->addWidget(pushButton);
    horizontalLayout->addWidget(pushButton_2);
    setCentralWidget(newCentralWidget);
    QObject::connect(pushButton, SIGNAL(clicked()), this, SLOT(slotLoad()));
    QObject::connect(pushButton_2, SIGNAL(clicked()), this, SLOT(slotUnload()));
}
qfontcache_crash::~qfontcache_crash()
{
    delete lib;
}
void qfontcache_crash::slotLoad()
{
    lib = new QLibrary(QDir::currentPath() + "/fontDLL/font_dll.dll");
    if(!lib->load()) {
        QString libfile = QFileDialog::getOpenFileName(this,"Select font_dll",QApplication::applicationFilePath());
        lib = new QLibrary(libfile);
    }
    if(!lib->load()) {
        qWarning() << "Couldn't load " + lib->fileName();
    }
    WidgetFunc loadFunc = reinterpret_cast<WidgetFunc>(lib->resolve("loadWidget"));
    if ( loadFunc == NULL )
    {
        qWarning() << "loadWidget failed";
        delete lib;
        lib = NULL;
        return;
    }
    dllWidget = loadFunc();
    QHBoxLayout *l = static_cast<QHBoxLayout*>(centralWidget()->layout());
    l->addWidget(dllWidget);
}
void qfontcache_crash::slotUnload()
{
    QHBoxLayout *l = static_cast<QHBoxLayout*>(centralWidget()->layout());
    l->removeWidget(dllWidget);
    QFunctionPointer unloadFunc = lib->resolve("unloadWidget");
    unloadFunc();
    lib->unload();
    delete lib;
    lib = NULL;
}
